Next: ATOMIC_FETCH_ADD, Previous: ATOMIC_CAS, Up: Intrinsic Procedures [Contents][Index]

### 9.27 `ATOMIC_DEFINE` — Setting a variable atomically

Description:

  `ATOMIC_DEFINE(ATOM, VALUE)` defines the variable ATOM with the value VALUE atomically. When STAT is present and the invokation was successful, it is assigned the value 0. If it is present and the invokation has failed, it is assigned a positive value; in particular, for a coindexed ATOM, if the remote image has stopped, it is assigned the value of `ISO_FORTRAN_ENV`’s `STAT_STOPPED_IMAGE` and if the remote image has failed, the value `STAT_FAILED_IMAGE`.

Standard:

  Fortran 2008 and later; with STAT, TS 18508 or later

Class:

  Atomic subroutine

Syntax:

  `CALL ATOMIC_DEFINE (ATOM, VALUE [, STAT])`

Arguments:

  ATOM | Scalar coarray or coindexed variable of either integer type with `ATOMIC_INT_KIND` kind or logical type with `ATOMIC_LOGICAL_KIND` kind.
  VALUE | Scalar of the same type as ATOM. If the kind is different, the value is converted to the kind of ATOM.
  STAT | (optional) Scalar default-kind integer variable.

Example:

      program atomic
        use iso_fortran_env
        integer(atomic_int_kind) :: atom[*]
        call atomic_define (atom[1], this_image())
      end program atomic

See also:

  ATOMIC_REF, ATOMIC_CAS, ISO_FORTRAN_ENV, ATOMIC_ADD, ATOMIC_AND, ATOMIC_OR, ATOMIC_XOR